{4- Localice un entero en un arreglo usando una versin recursiva del algoritmo de bsqueda binaria. El nmero que se debe buscar (clave) se debe ingresar como argumento por lnea de comandos. El arreglo de datos debe estar previamente ordenado (requisito de la bsqueda binaria). Comparar esta versin recursiva de la bsqueda binaria con la versin iterativa dada en el captulo 5.}
{Solucin en lenguaje Pascal}

PROGRAM cap09_ej04;

CONST N = 10;

TYPE t_arreglo_enteros = ARRAY[1..N] OF INTEGER;

FUNCTION buscar(clave: INTEGER; datos: t_arreglo_enteros; inferior, superior:
INTEGER): INTEGER;

VAR centro: INTEGER;
BEGIN
	IF (inferior > superior) THEN
	BEGIN
		{ Si el dato no se encuentra, retorna -1 }
		buscar := -1;
		END
	ELSE
	BEGIN
		centro := (inferior + superior) DIV 2; { Divisin entera }
		IF (datos[centro] = clave) THEN
			buscar := centro
		ELSE
			IF (datos[centro] > clave) THEN
				buscar := buscar(clave, datos, inferior, centro-1)
			ELSE
				buscar := buscar(clave, datos, centro+1, superior);
	END;
END;

VAR datos: t_arreglo_enteros;
	clave: INTEGER;
	error: INTEGER;
	pos: INTEGER;

{ Programa Principal }
BEGIN
	IF (ParamCount <> 1) THEN
	BEGIN
		WRITELN('Modo de uso: ', ParamStr(0), ' <clave a buscar>');
		EXIT;
	END;

VAL(ParamStr(1), clave, error);

datos[1] := 3;
datos[2] := 4;
datos[3] := 6;
datos[4] := 12;
datos[5] := 13;
datos[6] := 17;
datos[7] := 19;
datos[8] := 24;
datos[9] := 29;
datos[10] := 30;

{ Bsqueda }
pos := buscar(clave, datos, 1, N);

	IF (pos <> -1) THEN
		WRITELN('El entero ', clave, ' se encontr en la posicin ', pos)
	ELSE
		WRITELN('El entero ', clave, ' no pudo encontrarse');
END.